#include "Cut.h"

static void	get_values(select, temp_size, size_left, size_right, pos2jump)
t_select	*select;
off_t		temp_size;
off_t		*size_left;
off_t		*size_right;
off_t		*pos2jump;
{
  if (select->reverse == 0)
    {
      *size_left  =  temp_size / sizeof(t_sound_sample) - (select->chanel == 1 ? 0 : select->length);
      *size_right =  temp_size / sizeof(t_sound_sample) - (select->chanel == 0 ? 0 : select->length);
      *pos2jump   = select->begin + select->length;
    }
  else
    {
      *size_left  = (select->chanel == 1 ? temp_size / sizeof(t_sound_sample) : select->length);
      *size_right = (select->chanel == 0 ? temp_size / sizeof(t_sound_sample) : select->length);
      *pos2jump   = select->begin;
    }
}


int		cut(temp_gmurf, select)
t_tempgmurf	*temp_gmurf;
t_select	*select;
{
  int			fd;
  off_t			cpt;
  off_t			compt;
  off_t			nb2read;
  off_t			pos_left;
  off_t			pos_right;
  off_t			pos2jump;
  off_t			size;
  off_t			size_left;
  off_t			size_right;
  t_sound_sample	buf_src[BUFFER_SIZE];
  t_sound_sample	buf_trg[BUFFER_SIZE];

  if (access(redo_file, F_OK) != -1)
    unlink(redo_file);
  copy(temp_gmurf, select);
  fd = temp_gmurf->file;
  rename(temp_gmurf->tempname, undo_file);
  temp_gmurf->file = open(temp_gmurf->tempname, O_CREAT | O_TRUNC | O_APPEND | O_RDWR, 0644);
  
  get_values(select, temp_gmurf->temp_size, &size_left, &size_right, &pos2jump);

  size = size_left > size_right ? size_left : size_right;
  compt = 0;	pos_left = 0;	pos_right = 0;	cpt = 0; 
  while (compt < size)
    {
      nb2read = compt + BUFFER_SIZE <= size ? BUFFER_SIZE : size - compt;
      lseek(fd, pos_left * sizeof(t_sound_sample), SEEK_SET);
      read(fd, buf_src, nb2read * sizeof(t_sound_sample));
      for (cpt = 0; cpt < nb2read; cpt++)
	{
	  if ((((cpt + pos_left >= select->begin) && (cpt + pos_left <= select->begin + select->length))^(select->reverse != 0)) && (select->chanel != 1))
	    {
	      pos_left = (lseek(fd, pos2jump * sizeof(t_sound_sample) , SEEK_SET) / sizeof(t_sound_sample)) - cpt;
	      read(fd, &(buf_src[cpt]), (nb2read - cpt) * sizeof(t_sound_sample));
	      pos_left = pos2jump - cpt;
	    }
	  buf_trg[cpt].left = (compt + cpt < size_left ? buf_src[cpt].left : 0);
	}
      pos_left += nb2read;

      lseek(fd, pos_right * sizeof(t_sound_sample), SEEK_SET);
      read(fd, buf_src, nb2read * sizeof(t_sound_sample));
      for (cpt = 0; cpt < nb2read; cpt++)
	{
	  if ((((cpt + pos_right >= select->begin) && (cpt + pos_right <= select->begin + select->length))^(select->reverse != 0)) && (select->chanel != 0))
	    {
	      pos_right = (lseek(fd, pos2jump * sizeof(t_sound_sample) , SEEK_SET) / sizeof(t_sound_sample)) - cpt;
	      read(fd, &(buf_src[cpt]), (nb2read - cpt) * sizeof(t_sound_sample));
	      pos_right = pos2jump - cpt;
	    }
	  buf_trg[cpt].right = (compt + cpt < size_right ? buf_src[cpt].right : 0);
	}
      pos_right += nb2read;
      write(temp_gmurf->file, buf_trg, nb2read * sizeof(t_sound_sample));
      
      compt += nb2read;
    }
  temp_gmurf->temp_size = give_file_size(temp_gmurf->file);
  return (0);
}
