/*
** draw_wav_funcs_basic.c for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Wed Mar  3 20:00:27 1999 Rmi Coupet
** Last update Fri Mar  5 17:36:01 1999 Rmi Coupet
*/

#include "draw_wav_funcs_basic.h"


gint		draw_wav_basic(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  Waveditor		*wve ;
  Wavwin		*ww ;
  GdkRectangle		rec ;
  int 			iwidth ; /* width of the drawing area */
  int			iheight ; /* height of the drawing area */
  size_t 		begin ; /* just where to begin */
  size_t		width ;  /* size in gint16 of the piece of wave to show */
  t_sound_sample	buffer[BUF_SIZE] ;
  int			file ; /* file descriptor */
  size_t		rd ; /* number of bytes read during the last buffer read */
  size_t		i ; /* just a counter */
  size_t		new_i ;
  int			mid ;
  size_t		nb ;  /* number of gint16 read since start */
  size_t		nb_av ; /* number of gint16 read before the last buffer read */  
  size_t		just_for_speed ;
  float			coefx ; 
  float			coefy ;
  int			x ;
  int			y ;  
  GdkColor		*color ;
  GdkColor		*color1 ;
  GdkColormap* 		CMap ;
  GdkGC			*gc ;
  GdkGC			*gc1 ;
  GdkGC			*black_gc ;
  GdkGC			*gc_tmp ;
  
  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  
  color = (GdkColor *) malloc(sizeof(GdkColor)) ;
  CMap = gdk_window_get_colormap(MainWindow->window) ;
  gc = gdk_gc_new(MainWindow->window) ;
  SetColor(color, WAV_RED, WAV_GREEN, WAV_BLUE) ;
  gdk_color_alloc(CMap, color) ;
  gdk_gc_set_foreground(gc, color) ;
  gdk_gc_set_background(gc, color) ;

  color1 = (GdkColor *) malloc(sizeof(GdkColor)) ;
  gc1 = gdk_gc_new(MainWindow->window) ;
  SetColor(color, 0, 255, 255) ;
  gdk_color_alloc(CMap, color1) ;
  gdk_gc_set_foreground(gc1, color1) ;
  gdk_gc_set_background(gc1, color1) ;

  iwidth = wve->DrawingArea[LEFT]->allocation.width ;
  iheight = wve->DrawingArea[LEFT]->allocation.height ;

  black_gc = wve->DrawingArea[LEFT]->style->black_gc ;

  if (wve->there_is_a_selection && ww->invert)
  {
    gc_tmp = black_gc ;
    black_gc = gc ;
    gc = gc_tmp ;
  }

  /* draw a black retangle in both channels */
  gdk_draw_rectangle (wve->pixmap[LEFT],
		      black_gc, TRUE, 0, 0, iwidth, iheight);
  gdk_draw_rectangle (wve->pixmap[RIGHT],
		      black_gc, TRUE, 0, 0, iwidth, iheight);  

  if ( (wve->there_is_a_selection) && ( (wve->selection.x <= wve->part_watched.y)  && 
	 (wve->selection.y >= wve->part_watched.x) ) )
  {
    x = wve->selection.x <= wve->part_watched.x ? 0 : 
      (wve->selection.x - wve->part_watched.x) * iwidth / 
      (wve->part_watched.y - wve->part_watched.x) ;
    y = wve->selection.y >= wve->part_watched.y ? iwidth : 
      (wve->selection.y - wve->part_watched.x) * iwidth / 
      (wve->part_watched.y - wve->part_watched.x) ;
      
    gdk_draw_rectangle (wve->pixmap[LEFT], gc, TRUE,
			x, 0, y - x, iheight);
    gdk_draw_rectangle (wve->pixmap[RIGHT], gc, TRUE,
			x, 0, y - x, iheight);
  } else 
  {
    x = iwidth + 1 ;
    y = x ;
  }
  
  nb_av = nb = begin = wve->part_watched.x ;
  width = wve->part_watched.y  - begin + 1;
 
  file = ww->tempgmurf->file ;
  mid = iheight /2 -1 ;
  coefx = width / (float) iwidth ;
  coefy = mid / (float) MAX_16BITS ;
  lseek(file, nb * 4, SEEK_SET) ;
  
  nb += (rd = read(file, buffer, BUF_SIZE*4))/4 ;
  /* Reading File Loop */
  for (i = 0; i < iwidth; i ++)
  {
    new_i = i * coefx + begin;
    if (new_i > nb)
      while ((rd != 0) && (new_i > nb))
      {
	nb_av = nb ;
	nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
      }
    /* Draw the line in the left then right channel */
    just_for_speed = new_i - nb_av ;
    if ( (i >= x) && (i <= y) )
    {
      gdk_draw_line(wve->pixmap[RIGHT], black_gc,
		    i, mid + (buffer[just_for_speed]).right * coefy ,
		    i, mid - (buffer[just_for_speed]).right * coefy ) ;
      gdk_draw_line(wve->pixmap[LEFT], black_gc,
		    i, mid + (buffer[just_for_speed]).left * coefy ,
		    i, mid - (buffer[just_for_speed]).left * coefy ) ;
    } else
    {
      gdk_draw_line(wve->pixmap[RIGHT], gc,
		    i, mid + (buffer[just_for_speed]).right * coefy ,
		    i, mid - (buffer[just_for_speed]).right * coefy ) ;
      gdk_draw_line(wve->pixmap[LEFT], gc,
		    i, mid + (buffer[just_for_speed]).left * coefy ,
		    i, mid - (buffer[just_for_speed]).left * coefy ) ;
    }
  }
  
  if (! (wve->there_is_a_selection) )
  {
    if (wve->left_positionned)
    {
      if ( (wve->selection.x >= wve->part_watched.x)
	   && (wve->selection.x <= wve->part_watched.y) )
      {
	gdk_draw_line(wve->pixmap[LEFT],
		      gc1,	
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), iheight) ;
	gdk_draw_line(wve->pixmap[RIGHT],
		      gc1,	
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), iheight) ;
      }
    } else if (wve->right_positionned)
      if ( (wve->selection.y >= wve->part_watched.x)
	   && (wve->selection.y <= wve->part_watched.y) )
      {
	gdk_draw_line(wve->pixmap[LEFT],
		      gc1,	
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), iheight) ;
	gdk_draw_line(wve->pixmap[RIGHT],
		      gc1,	
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), iheight) ;
      }  
  }
  
    
  /* Redraw of the dranwing areas */
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gtk_widget_draw(wve->DrawingArea[LEFT], &rec);
  gtk_widget_draw(wve->DrawingArea[RIGHT], &rec);
  return TRUE ;
}

gint		draw_wav_sinus(widget, data)
GtkWidget	*widget ;
gpointer	data ;
{
  Waveditor		*wve ;
  Wavwin		*ww ;
  GdkRectangle		rec ;
  int 			iwidth ; /* width of the drawing area */
  int			iheight ; /* height of the drawing area */
  size_t 		begin ; /* just where to begin */
  size_t		width ;  /* size in gint16 of the piece of wave to show */
  t_sound_sample	buffer[BUF_SIZE] ;
  int			file ; /* file descriptor */
  size_t		rd ; /* number of bytes read during the last buffer read */
  size_t		i ; /* just a counter */
  size_t		new_i ;
  int			mid ;
  int			x ;
  int			y ;
  size_t		nb ;  /* number of gint16 read since start */
  size_t		nb_av ; /* number of gint16 read before the last buffer read */  
  size_t		just_for_speed ;
  float			coefx ; 
  float			coefy ;  
  int			x1 ;
  int			x2 ;
  GdkColor		*color ;
  GdkColor		*color1 ;
  GdkColormap* 		CMap ;
  GdkGC			*gc ;
  GdkGC			*gc1 ;

  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;

  color = (GdkColor *) malloc(sizeof(GdkColor)) ;
  CMap = gdk_window_get_colormap(
    MainWindow->window) ;
  gc = gdk_gc_new(wve->DrawingArea[RIGHT]->window) ;
  SetColor(color, WAV_RED, WAV_GREEN, WAV_BLUE) ;
  gdk_color_alloc(CMap, color) ;
  gdk_gc_set_foreground(gc, color) ;
  gdk_gc_set_background(gc, color) ;

  color1 = (GdkColor *) malloc(sizeof(GdkColor)) ;
  gc1 = gdk_gc_new(MainWindow->window) ;
  SetColor(color, 0, 255, 255) ;
  gdk_color_alloc(CMap, color1) ;
  gdk_gc_set_foreground(gc1, color1) ;
  gdk_gc_set_background(gc1, color1) ;
  

  iwidth = wve->DrawingArea[LEFT]->allocation.width ;
  iheight = wve->DrawingArea[LEFT]->allocation.height ;
  /* draw a black retangle in both channels */
  gdk_draw_rectangle (wve->pixmap[LEFT],
		      wve->DrawingArea[LEFT]->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);
  gdk_draw_rectangle (wve->pixmap[RIGHT],
		      wve->DrawingArea[RIGHT]->style->black_gc,
		      TRUE,
		      0, 0,
		      iwidth, iheight);
  
  if ( (wve->there_is_a_selection) && ( (wve->selection.x <= wve->part_watched.y)  && 
					(wve->selection.y >= wve->part_watched.x) ) )
  {
    x1 = wve->selection.x <= wve->part_watched.x ? 0 : 
      (wve->selection.x - wve->part_watched.x) * iwidth / 
      (wve->part_watched.y - wve->part_watched.x) ;
    x2 = wve->selection.y >= wve->part_watched.y ? iwidth : 
      (wve->selection.y - wve->part_watched.x) * iwidth / 
      (wve->part_watched.y - wve->part_watched.x) ;
      
    gdk_draw_rectangle (wve->pixmap[LEFT],
//			wve->DrawingArea[LEFT]->style->white_gc,
			gc,
			TRUE,
			x1, 0, x2 - x1, iheight);
    gdk_draw_rectangle (wve->pixmap[RIGHT],
//			wve->DrawingArea[RIGHT]->style->white_gc,
			gc,
			TRUE,
			x1, 0, x2 - x1, iheight);
  } else 
  {
    x1 = iwidth + 1 ;
    x2 = x1 ;
  }

  nb_av = nb = begin = wve->part_watched.x ;
  width = wve->part_watched.y  - begin ;
 
  file = ww->tempgmurf->file ;
  y = mid = iheight /2 -1 ;
  x = 0 ;
  coefx = width / (float) iwidth ;
  coefy = mid / (float) MAX_16BITS ;
  lseek(file, nb * 4, SEEK_SET) ;
  
  nb += (rd = read(file, buffer, BUF_SIZE*4))/4 ;
  /* Reading File Loop */
  for (i = 0; i < iwidth; i ++){
    new_i = i * coefx + begin;
    if (new_i > nb)
      while ((rd != 0) && (new_i > nb)){
	nb_av = nb ;
	nb += (rd = read(file, buffer, BUF_SIZE*4)) / 4 ;
      }
    /* Draw the line in the left then right channel */
    just_for_speed = new_i - nb_av ;
    if ( (i >= x1) && (i <= x2) )
    {
      gdk_draw_line(wve->pixmap[RIGHT],
		    wve->DrawingArea[RIGHT]->style->white_gc,
		    x, y ,
		    i, mid + (buffer[just_for_speed]).right * coefy ) ;
      gdk_draw_line(wve->pixmap[LEFT],
		    wve->DrawingArea[LEFT]->style->white_gc,
		    x, y,
		    i, mid + (buffer[just_for_speed]).left * coefy ) ;
    } else {
      gdk_draw_line(wve->pixmap[RIGHT],
		    gc,
		    x, y ,
		    i, mid + (buffer[just_for_speed]).right * coefy ) ;
      gdk_draw_line(wve->pixmap[LEFT],
		    gc,
		    x, y,
		    i, mid + (buffer[just_for_speed]).left * coefy ) ;
    }
    
    
/* Save the x & y values */
    x = i ;
    y = mid + (buffer[just_for_speed]).left * coefy ;
  }
  
  gdk_draw_line(wve->pixmap[RIGHT],
		gc1,
		0, mid ,
		iwidth, mid) ;
  gdk_draw_line(wve->pixmap[LEFT],
		gc1,
		0, mid,
		iwidth, mid) ;

  if (! (wve->there_is_a_selection) )
  {
    if (wve->left_positionned)
    {
      if ( (wve->selection.x >= wve->part_watched.x)
	   && (wve->selection.x <= wve->part_watched.y) )
      {
	gdk_draw_line(wve->pixmap[LEFT],
		      gc1,	
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), iheight) ;
	gdk_draw_line(wve->pixmap[RIGHT],
		      gc1,	
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.x - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), iheight) ;
      }
    } else if (wve->right_positionned)
      if ( (wve->selection.y >= wve->part_watched.x)
	   && (wve->selection.y <= wve->part_watched.y) )
	{
	  gdk_draw_line(wve->pixmap[LEFT],
		      gc1,	
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
			(wve->part_watched.y - wve->part_watched.x), iheight) ;
	  gdk_draw_line(wve->pixmap[RIGHT],
		      gc1,	
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
		      (wve->part_watched.y - wve->part_watched.x), 0,
		      (wve->selection.y - wve->part_watched.x) * iwidth / 
			(wve->part_watched.y - wve->part_watched.x), iheight) ;
	}
  }
  
  /* Redraw of the dranwing areas */
  rec.x = 0;
  rec.y = 0;
  rec.width = iwidth ;
  rec.height = iheight ;

  gtk_widget_draw(wve->DrawingArea[LEFT], &rec);
  gtk_widget_draw(wve->DrawingArea[RIGHT], &rec);
  return TRUE ;
}












